<template>
  <div class="sw-gs-offcanvas-last-seen sw-side-last-seen">
    <SfLoader class="widget-loader" :loading="isLastSeenLoading" v-if="isLastSeenLoading"/>
    <template v-else>
      <div v-if="lastSeen && lastSeen.length > 0" key="my-last-seen" class="sw-gs-offcanvas-last-seen-inner">
        <div v-if="isGuide" class="sw-gs-offcanvas-last-seen-products-guide-header">
          {{ $t('Your (Guide) last seen products') }}
        </div>

        <SwPluginSlot name="gs-offcanvas-last-seen-products-before"/>
        <transition-group name="fade" tag="div" class="sw-gs-offcanvas-last-seen-products">
          <SwGsOffcanvasCollectionProduct v-for="product in lastSeen" :key="product.id" :product="product"/>
        </transition-group>
        <SwPluginSlot name="gs-offcanvas-last-seen-products-after"/>
      </div>
      <div v-else key="empty-last-seen" class="sw-gs-offcanvas-last-seen-empty">
        <SfHeading :title="$t('Your last seen products list is empty')" :level="2" class="empty-last-seen__heading"/>
      </div>
    </template>
  </div>
</template>

<script lang="ts">
  import { SfHeading } from "@storefront-ui/vue"
  import SwButton from "@/components/atoms/SwButton.vue"
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"
  import { SfLoader } from "@storefront-ui/vue";
  import SwGsOffcanvasCollectionProduct from "./SwGsOffcanvasCollectionProduct.vue";
  import { useLastSeen } from "../../logic/composables/useLastSeen";
  import { useAppointment } from "../../logic/composables/useAppointment";
  import { onMounted } from "@vue/composition-api"

  export default {
    name: "SwGsOffcanvasLastSeen",
    components: {
      SwGsOffcanvasCollectionProduct,
      SfHeading,
      SwPluginSlot,
      SfLoader,
      SwButton,
    },
    setup() {
      const { loadLastSeen, lastSeen, isLastSeenLoading } = useLastSeen();
      const { isGuide } = useAppointment();


      onMounted(async () => {
        await loadLastSeen();
      });

      return {
        lastSeen,
        isGuide,
        isLastSeenLoading
      }
    }
  }
</script>
<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .widget-loader {
    height: 100px;
  }

  .sw-side-last-seen {
    --property-name-font-size: var(--font-size--lg);
    --property-value-font-size: var(--font-size--lg);
    --sidebar-bottom: var(--bottom-navigation-height, 0);
    --sidebar-bottom-padding: var(--spacer-sm) var(--spacer-sm) var(--spacer-xl);

    & > * {
      --sidebar-content-padding: 0 var(--spacer-xs) var(--spacer-xs) var(--spacer-xs);
    }

    @include for-desktop {
      --sidebar-bottom: 0;
      & > * {
        --sidebar-bottom-padding: var(--spacer-base);
        --sidebar-content-padding: 0 var(--spacer-base) var(--spacer-base) var(--spacer-base);
      }
    }
  }

  .sw-gs-offcanvas-last-seen-inner {
    flex: 1;
    display: flex;
    flex-direction: column;
  }

  .sw-gs-offcanvas-last-seen-products-guide-header {
    margin-bottom: var(--spacer-xs);
  }

  .sw-gs-offcanvas-last-seen-products {
    display: flex;
    flex-wrap: wrap;
    margin-left: calc(-1 * var(--spacer-2xs));
    margin-right: calc(-1 * var(--spacer-2xs));

    ::v-deep .sw-gs-offcanvas-collection-product {
      flex-wrap: wrap;
      position: relative;
      width: 100%;
      flex: 0 0 50%;
      max-width: 50%;
      margin-bottom: 30px;
    }
  }

  .sw-gs-offcanvas-last-seen-empty {
    --heading-description-margin: 0 0 var(--spacer-xl) 0;
    --heading-title-margin: var(--spacer-base) 0;
    --heading-title-color: var(--c-primary);
    --heading-title-font-weight: var(--font-weight--semibold);
    display: flex;
    flex: 1;
    align-items: center;
    flex-direction: column;
  }
</style>
